Package: Copula.surv
Type: Package
Title: Analysis of Bivariate Survival Data Based on Copulas
Version: 3.1
Date: 2026-5-25
Authors@R: person(given = "Takeshi",
                      family = "Emura",
                      role = c("aut", "cre"),
                      email = "takeshiemura@gmail.com")
Maintainer: Takeshi Emura <takeshiemura@gmail.com>
Description: Simulating bivariate survival data from various copula models.
 Estimating bivariate copula models with semiparametric or Weibull margins under various copulas.  
 Two different ways to estimate the association parameter in copula models are implemented.
 A goodness-of-fit test for the Gumbel and Clayton copulas is also implemented for semiparametric models.
 See Emura, Lin and Wang (2010) <doi:10.1016/j.csda.2010.03.013> for details.
License: GPL-2
Depends: MASS
NeedsCompilation: no
Packaged: 2026-05-25 03:45:51 UTC; takes
Author: Takeshi Emura [aut, cre]
Repository: CRAN
Date/Publication: 2026-05-25 04:00:03 UTC
Built: R 4.5.2; ; 2026-05-25 06:50:14 UTC; unix

Package: Copula.surv
Type: Package
Title: Analysis of Bivariate Survival Data Based on Copulas
Version: 1.8
Date: 2025-1-31
Authors@R: person(given = "Takeshi",
                      family = "Emura",
                      role = c("aut", "cre"),
                      email = "takeshiemura@gmail.com")
Maintainer: Takeshi Emura <takeshiemura@gmail.com>
Description: Simulating bivariate survival data from copula models.
 Estimation of the association parameter in copula models.
 Two different ways to estimate the association parameter in copula models are implemented.
 A goodness-of-fit test for a given copula model is implemented.
 See Emura, Lin and Wang (2010) <doi:10.1016/j.csda.2010.03.013> for details.
License: GPL-2
Depends: MASS
NeedsCompilation: no
Packaged: 2025-01-31 06:20:18 UTC; takes
Author: Takeshi Emura [aut, cre]
Repository: CRAN
Date/Publication: 2025-01-31 06:40:02 UTC
Built: R 4.5.0; ; 2025-01-31 07:09:42 UTC; unix

Package: Copula.surv
Type: Package
Title: Analysis of Bivariate Survival Data Based on Copulas
Version: 1.6
Date: 2024-05-22
Author: Takeshi Emura 
Maintainer: Takeshi Emura <takeshiemura@gmail.com>
Description: Simulating bivariate survival data from copula models.
 Estimation of the association parameter in copula models.
 Two different ways to estimate the association parameter in copula models are implemented.
 A goodness-of-fit test for a given copula model is implemented.
 See Emura, Lin and Wang (2010) <doi:10.1016/j.csda.2010.03.013> for details.
License: GPL-2
NeedsCompilation: no
Packaged: 2024-05-22 07:15:38 UTC; takes
Repository: CRAN
Date/Publication: 2024-05-22 07:40:02 UTC
Built: R 4.2.3; ; 2024-05-22 10:31:29 UTC; unix

Package: Copula.surv
Type: Package
Title: Analysis of Bivariate Survival Data Based on Copulas
Version: 3.1
Date: 2026-5-25
Authors@R: person(given = "Takeshi",
                      family = "Emura",
                      role = c("aut", "cre"),
                      email = "takeshiemura@gmail.com")
Maintainer: Takeshi Emura <takeshiemura@gmail.com>
Description: Simulating bivariate survival data from various copula models.
 Estimating bivariate copula models with semiparametric or Weibull margins under various copulas.  
 Two different ways to estimate the association parameter in copula models are implemented.
 A goodness-of-fit test for the Gumbel and Clayton copulas is also implemented for semiparametric models.
 See Emura, Lin and Wang (2010) <doi:10.1016/j.csda.2010.03.013> for details.
License: GPL-2
Depends: MASS
NeedsCompilation: no
Packaged: 2026-05-25 03:45:51 UTC; takes
Author: Takeshi Emura [aut, cre]
Repository: CRAN
Date/Publication: 2026-05-25 04:00:03 UTC
Built: R 4.6.0; ; 2026-05-25 04:04:25 UTC; unix

exportPattern("^[[:alpha:]]+")
importFrom("stats", "pchisq", "uniroot", "dnorm", "integrate", "pnorm", "runif", "var", "qchisq", "qnorm", "sd","nlm")
importFrom("graphics", "abline", "curve","points")
importFrom("stats", "pt", "rchisq")
importFrom("MASS", "mvrnorm")

Weib.reg.Clayton=function(x.obs,y.obs,dx,dy,zx,zy,
                          convergence.par=FALSE){

  x.obs[x.obs<=0]=min(1,min(x.obs[x.obs>0]))
  y.obs[y.obs<=0]=min(1,min(y.obs[y.obs>0]))

  tx = x.obs
  ty = y.obs
  zx = as.matrix(zx)
  zy = as.matrix(zy)
  px = ncol(zx)
  py = ncol(zy)
  N = length(x.obs)
  
  mx=sum(dx)
  my=sum(dy)
  mxy=sum(dx*dy)
  
  count=c(N=N,Event.X=mx,Event.Y=my)
  CEN=c(Censor.X=(N-mx)/N,Censor.Y=(N-my)/N)

  ## Likelihood function ##
  l.func=function(phi){
    gx=exp(pmax(pmin(phi[1:2], 500), -500))
    gy=exp(pmax(pmin(phi[3:4], 500), -500))
    a=min(exp(phi[5]), exp(3))
    bx=phi[(5+1):(5+px)]
    by=phi[(5+px+1):(5+px+py)]
    bzx=as.vector(zx%*%bx)
    bzy=as.vector(zy%*%by)
    Sx=pmin(exp(a*exp(bzx)*gx[1]*tx^gx[2]),exp(500))
    Sy=pmin(exp(a*exp(bzy)*gy[1]*ty^gy[2]),exp(500))
    Ex=Sx/(Sx+Sy-1)
    Ey=Sy/(Sx+Sy-1)
    l=mx*(log(gx[1])+log(gx[2]))+(gx[2]-1)*sum(dx*log(tx))+sum(dx*bzx)
    l=l+my*(log(gy[1])+log(gy[2]))+(gy[2]-1)*sum(dy*log(ty))+sum(dy*bzy)
    l=l+mxy*log(a+1)+sum(dx*log(Ex))+sum(dy*log(Ey))-1/a*sum(log(Sx+Sy-1))
    -l
  }
  
  p0=rep(0,5+px+py)
  p0[c(1,3)]=p0[c(1,3)]-log(c(mean(tx),mean(ty)))
  res=nlm(l.func,p=p0,hessian=TRUE)
  ML=-res$minimum
  HL=-res$hessian
  V=solve(-HL,tol=10^(-50))
  DF=5+px+py
  AIC=2*DF-2*(-l.func(res$estimate))
  BIC=log(N)*DF-2*(-l.func(res$estimate))
  convergence_res=c(ML=ML,DF=DF,AIC=AIC,BIC=BIC,code=res$code,
                    No.of.iterations=res$iterations)
  est=c(exp(res$est[1:5]),res$est[(5+1):(5+px+py)])
  D=diag(c(est[1:5],rep(1,px+py)))
  est_var=D%*%V%*%D

  bx_est=res$est[(5+1):(5+px)]
  by_est=res$est[(5+px+1):(5+px+py)]
  g_est=exp(res$est[1:2])
  h_est=exp(res$est[3:4])
  a_est=exp(res$est[5])
  tau_est=a_est/(a_est+2)

  bx_se=sqrt(diag(V)[(5+1):(5+px)])
  by_se=sqrt(diag(V)[(5+px+1):(5+px+py)])
  a_se=a_est*sqrt(diag(V)[5])
  tau_se=2/(a_est+2)^2*a_se
  g_var=diag(g_est)%*%V[1:2,1:2]%*%diag(g_est)
  h_var=diag(h_est)%*%V[3:4,3:4]%*%diag(h_est)
  g_se=sqrt(diag(g_var))
  h_se=sqrt(diag(h_var))

  bx_res=c(estimate=bx_est,SE=bx_se,
              Lower=bx_est-1.96*bx_se,Upper=bx_est+1.96*bx_se)
  by_res=c(estimate=by_est,SE=by_se,
              Lower=by_est-1.96*by_se,Upper=by_est+1.96*by_se)
  a_Lower=a_est*exp(-1.96*sqrt(diag(V)[5]))
  a_Upper=a_est*exp(1.96*sqrt(diag(V)[5]))
  a_res=c(Estimate=a_est,SE=a_se,Lower=a_Lower,Upper=a_Upper)
  tau_res=c(Estimate=tau_est,SE=tau_se,
            Lower=a_Lower/(a_Lower+2),Upper=a_Upper/(a_Upper+2))
  rx=c(Estimate=g_est[1],SE=g_se[1],Lower=g_est[1]*exp(-1.96*sqrt(diag(V)[1:1])),
       Upper=g_est[1]*exp(+1.96*sqrt(diag(V)[1:1])))
  vx=c(Estimate=g_est[2],SE=g_se[2],Lower=g_est[2]*exp(-1.96*sqrt(diag(V)[2:2])),
       Upper=g_est[2]*exp(+1.96*sqrt(diag(V)[2:2])))
  ry=c(Estimate=h_est[1],SE=h_se[1],Lower=h_est[1]*exp(-1.96*sqrt(diag(V)[3:3])),
       Upper=h_est[1]*exp(+1.96*sqrt(diag(V)[3:3])))
  vy=c(Estimate=h_est[2],SE=h_se[2],Lower=h_est[2]*exp(-1.96*sqrt(diag(V)[4:4])),
       Upper=h_est[2]*exp(+1.96*sqrt(diag(V)[4:4])))

  if (convergence.par==FALSE){convergence.parameters = NULL}else{
    convergence.parameters=list(log_estimate=res$est,gradient=-res$gradient,log_var=V)
  }
  list(Number=count,Proportion=CEN,
       beta_x=bx_res,beta_y=by_res,alpha=a_res,tau=tau_res,
       scale_x=rx,shape_y=ry,scale_y=ry,shape_y=ry,
       convergence=convergence_res,convergence.parameters=convergence.parameters)
}

U2.Clayton<-function(x.obs,y.obs,dx,dy,lower=0.001,upper=50,U.plot=TRUE){
  n=length(x.obs)

  U.func=function(theta){
    u=0
    for(i in 1:(n-1)){
      xi=x.obs[i];yi=y.obs[i];dxi=dx[i];dyi=dy[i]
      for(j in (i+1):n){
        xj=x.obs[j];yj=y.obs[j];dxj=dx[j];dyj=dy[j]
        Ox=(dxi&dxj)|(dxi&(!dxj)&(xi<xj))|((dxj)&(!dxi)&(xj<xi))
        Oy=(dyi&dyj)|(dyi&(!dyj)&(yi<yj))|((dyj)&(!dyi)&(yj<yi))
        if(Ox&Oy){
          xij=min(xi,xj);yij=min(yi,yj)
          Rij=sum( (x.obs>=xij)&(y.obs>=yij) )
          u=u+((xi-xj)*(yi-yj)>0)-(theta+1)/(theta+2)
        }
      }
    }
    u
  }

  if((U.func(lower)<0)&(U.func(upper)<0)){ theta=lower }else{
    theta=uniroot(U.func,lower=lower,upper=upper)$root
  }
  tau=theta/(theta+2)

  if(U.plot==TRUE){
    curve(U.func,lower,upper,xlab=expression(theta),
          ylab=expression(U[2](theta)))
    points(theta,U.func(theta),col="red",cex=1)
    abline(h=0,lty="dotted",col="blue")
  }

  return(c(theta=theta,tau=tau))
}

Test.Clayton<-function(x.obs,y.obs,dx,dy,lower=0.001,upper=50,U.plot=TRUE){
  res1=U1.Clayton(x.obs,y.obs,dx,dy,lower,upper,U.plot)
  res2=U2.Clayton(x.obs,y.obs,dx,dy,lower,upper,U.plot)
  theta1=res1["theta"]
  theta2=res2["theta"]
  tau1=res1["tau"]
  tau2=res2["tau"]
  stat=log(theta1+1)-log(theta2+1)

  Stat<-function(x.obs1,y.obs1,dx1,dy1){
    theta1=U1.Clayton(x.obs1,y.obs1,dx1,dy1,lower,upper,U.plot=FALSE)["theta"]
    theta2=U2.Clayton(x.obs1,y.obs1,dx1,dy1,lower,upper,U.plot=FALSE)["theta"]
    log(theta1+1)-log(theta2+1)
  }
  n=length(x.obs)
  T.del=numeric(n)
  for(i in 1:n){
    T.del[i]=Stat(x.obs[-i],y.obs[-i],dx[-i],dy[-i])
  }
  V=(n-1)^2/n*var(T.del)
  Z=stat/sqrt(V)
  P=1-pchisq(Z^2,df=1)

  Res=c(theta1=unname(theta1),tau1=unname(tau1),
        theta2=unname(theta2),tau2=unname(tau2),
        Z=unname(Z),P=unname(P))
  return(Res)
}

simu.BB1reg <-
  function(n,alpha,delta=0,scale1=1,scale2=1,shape1=1,shape2=1,
           beta1=0,beta2=0,beta12=0,Z.dist=runif,...){

  X.vec=Y.vec=Z.vec=U.vec=V.vec=numeric(n)
  for (i in 1:n){
    Z.vec[i]=Z.dist(1,...)
    r1=scale1*exp(beta1*Z.vec[i])
    r2=scale2*exp(beta2*Z.vec[i])
    a=alpha*exp(beta12*Z.vec[i])
    dat=simu.BB1(n=1,alpha=a,delta=delta,scale1=r1,scale2=r2,
                 shape1=shape1,shape2=shape2)
    U.vec[i]=dat[,"U"]
    V.vec[i]=dat[,"V"]
    X.vec[i]=dat[,"X"]
    Y.vec[i]=dat[,"Y"]
  }
  cbind(U=U.vec,V=V.vec,X=X.vec,Y=Y.vec,Z=Z.vec)

}

simu.t=function(n,alpha,df=1,scale1=1,scale2=1,shape1=1,shape2=1,
                     Print=FALSE){

  U.vec=V.vec=X.vec=Y.vec=numeric(n)
  for (i in 1:n){
    dat=mvrnorm(mu=c(0,0),Sigma=matrix(c(1,alpha,alpha,1),ncol=2))
    C2=rchisq(1,df=df)
    X=dat[1]/sqrt(C2/df)
    Y=dat[2]/sqrt(C2/df)
    U=pt(X,df=df)
    V=pt(Y,df=df)
    U.vec[i]=U
    V.vec[i]=V
    X.vec[i]=(-log(U)/scale1)^(1/shape1)
    Y.vec[i]=(-log(V)/scale2)^(1/shape2)
  }

  if(Print==TRUE){
    meanX=scale1^(-1/shape1)*gamma(1+1/shape1)
    meanY=scale2^(-1/shape2)*gamma(1+1/shape2)
    Tau=2/pi*asin(alpha)
    print(c(true_Kendall_tau=Tau,meanX=meanX,meanY=meanY))
  }

  cbind(U=U.vec,V=V.vec,X=X.vec,Y=Y.vec)
}

simu.Clayton=function(n,alpha,scale1=1,scale2=1,shape1=1,shape2=1,
                      Print=FALSE){

  V = runif(n, 0, 1)
  W = runif(n, 0, 1)
  U = (V^(-alpha)*W^(-alpha/(alpha+1))-V^(-alpha)+1)^(-1/alpha)

  X=(-log(U)/scale1)^(1/shape1)
  Y=(-log(V)/scale2)^(1/shape2)

  if(Print==TRUE){
    meanX=scale1^(-1/shape1)*gamma(1+1/shape1)
    meanY=scale2^(-1/shape2)*gamma(1+1/shape2)
    print(
      c(true_Kendall_tau=alpha/(alpha+2),meanX=meanX,meanY=meanY)
    )
  }
  cbind(U,V,X,Y)
}

simu.BB1=function(n,alpha,delta=0,scale1=1,scale2=1,shape1=1,shape2=1,
                  Print=FALSE){

  U.vec=V.vec=X.vec=Y.vec=numeric(n)
  a=alpha
  d=delta
  for (i in 1:n){
    U=runif(1, 0, 1)
    W=runif(1, 0, 1)
    U1=U^(-a)-1
    func=function(v){
      v1=v^(-a)-1
      A=(U1^(d+1)+v1^(d+1))^(1/(d+1))
      U^(-a-1)*U1^d*A^(-d)*(1+A)^(-(1+a)/a)-W
    }
    V=uniroot(func,lower=0.00000000001,upper=0.9999999999)$root

    U.vec[i]=U
    V.vec[i]=V
    X.vec[i]=(-log(U)/scale1)^(1/shape1)
    Y.vec[i]=(-log(V)/scale2)^(1/shape2)
  }

  if(Print==TRUE){
    meanX=scale1^(-1/shape1)*gamma(1+1/shape1)
    meanY=scale2^(-1/shape2)*gamma(1+1/shape2)
    print(
      c(true_Kendall_tau=1-2/(d+1)/(a+2),meanX=meanX,meanY=meanY)
    )
  }

  cbind(U=U.vec,V=V.vec,X=X.vec,Y=Y.vec)
}

simu.GB=function(n,alpha,scale1=1,scale2=1,shape1=1,shape2=1,
                     Print=FALSE){

  U.vec=V.vec=X.vec=Y.vec=numeric(n)
  for (i in 1:n){
    U=runif(1, 0, 1)
    W=runif(1, 0, 1)
    GB = function(v){
      (1-alpha*log(v))*U^(-alpha*log(v))*v-W
    }
    V=uniroot(GB,lower=0.00000000001,upper=0.9999999999)$root

    U.vec[i]=U
    V.vec[i]=V
    X.vec[i]=(-log(U)/scale1)^(1/shape1)
    Y.vec[i]=(-log(V)/scale2)^(1/shape2)
  }

  if(Print==TRUE){
    meanX=scale1^(-1/shape1)*gamma(1+1/shape1)
    meanY=scale2^(-1/shape2)*gamma(1+1/shape2)
    func1=function(x){x*(1-alpha*log(x))*log(1-alpha*log(x))}
    if(alpha==0){Tau=0}else{Tau=1-4/alpha*integrate(func1,0,1)$value}
    print(c(true_Kendall_tau=Tau,meanX=meanX,meanY=meanY))
  }

  cbind(U=U.vec,V=V.vec,X=X.vec,Y=Y.vec)
}

simu.Frank=function(n,alpha,scale1=1,scale2=1,shape1=1,shape2=1,
                    Print=FALSE){
  if((0<=alpha)&(alpha<0.0001)){alpha=0.0001}
  if((0>alpha)&(-0.0001<alpha)){alpha=-0.0001}

  U.vec=V.vec=X.vec=Y.vec=numeric(n)
  for (i in 1:n){
    U=runif(1, 0, 1)
    W=runif(1, 0, 1)
    A=exp(-alpha*U)-W*exp(-alpha*U)+W*exp(-alpha)
    B=exp(-alpha*U)-W*exp(-alpha*U)+W
    V=-log(A/B)/alpha
    U.vec[i]=U
    V.vec[i]=V
    X.vec[i]=(-log(U)/scale1)^(1/shape1)
    Y.vec[i]=(-log(V)/scale2)^(1/shape2)
  }

  if(Print==TRUE){
    meanX=scale1^(-1/shape1)*gamma(1+1/shape1)
    meanY=scale2^(-1/shape2)*gamma(1+1/shape2)
    func1=function(x){x/(exp(x)-1)}
    Tau=1-4/alpha*(1-integrate(func1,0,alpha)$value/alpha)
    print(c(true_Kendall_tau=Tau,meanX=meanX,meanY=meanY))
  }
  cbind(U=U.vec,V=V.vec,X=X.vec,Y=Y.vec)
}

simu.CC=function(n,alpha,scale1=1,scale2=1,shape1=1,shape2=1,
                     Print=FALSE){

  U.vec=V.vec=X.vec=Y.vec=numeric(n)
  for (i in 1:n){
    U=runif(1, 0, 1)
    W=runif(1, 0, 1)
    CC = function(v){
      (v-alpha*U*v*(1-v))*exp(alpha*(1-U)*(1-v))-W
    }
    V=uniroot(CC,lower=0.00000000001,upper=0.9999999999)$root

    U.vec[i]=U
    V.vec[i]=V
    X.vec[i]=(-log(U)/scale1)^(1/shape1)
    Y.vec[i]=(-log(V)/scale2)^(1/shape2)
  }

  if(Print==TRUE){
    meanX=scale1^(-1/shape1)*gamma(1+1/shape1)
    meanY=scale2^(-1/shape2)*gamma(1+1/shape2)

    func1=function(u){
      func2=function(v){
        C=u*v*exp(alpha*(1-u)*(1-v))
        D=(1+(3*u*v-u-v)*alpha+u*v*(1-u)*(1-v)*alpha^2)
        C*D*exp(alpha*(1-u)*(1-v))
      }
      integrate(func2,0,1)$value
    }
    Tau=4*integrate(Vectorize(func1),0,1)$value-1
    print(c(true_Kendall_tau=Tau,meanX=meanX,meanY=meanY))
  }

  cbind(U=U.vec,V=V.vec,X=X.vec,Y=Y.vec)
}

simu.FGM=function(n,alpha,scale1=1,scale2=1,shape1=1,shape2=1,
                  Print=FALSE){

  if((-1>alpha)|(alpha>1)){warning("Should be -1<=alpha<=1")}

  U.vec=V.vec=X.vec=Y.vec=numeric(n)
  for (i in 1:n){
    U=runif(1,0,1)
    W=runif(1,0,1)
    func=function(v){ W-v*(1+alpha*(1-v)*(1-2*U)) }
    V=uniroot(func,lower=0,upper=1)$root
    U.vec[i]=U
    V.vec[i]=V
    X.vec[i]=(-log(U)/scale1)^(1/shape1)
    Y.vec[i]=(-log(V)/scale2)^(1/shape2)
  }

  if(Print==TRUE){
    meanX=scale1^(-1/shape1)*gamma(1+1/shape1)
    meanY=scale2^(-1/shape2)*gamma(1+1/shape2)
    print(
      c(true_Kendall_tau=2*alpha/9,meanX=meanX,meanY=meanY)
    )
  }
  cbind(U=U.vec,V=V.vec,X=X.vec,Y=Y.vec)
}

U1.Clayton<-function(x.obs,y.obs,dx,dy,lower=0.001,upper=50,U.plot=TRUE){

    n=length(x.obs)

    U.func=function(theta){
      u=0
      for(i in 1:(n-1)){
        xi=x.obs[i];yi=y.obs[i];dxi=dx[i];dyi=dy[i]
        for(j in (i+1):n){
          xj=x.obs[j];yj=y.obs[j];dxj=dx[j];dyj=dy[j]
          Ox=(dxi&dxj)|(dxi&(!dxj)&(xi<xj))|((dxj)&(!dxi)&(xj<xi))
          Oy=(dyi&dyj)|(dyi&(!dyj)&(yi<yj))|((dyj)&(!dyi)&(yj<yi))
          if(Ox&Oy){
            xij=min(xi,xj);yij=min(yi,yj)
            Rij=sum( (x.obs>=xij)&(y.obs>=yij) )
            Wij=(theta+2)/(theta+1)/(Rij+theta)
            u=u+Wij*(  ((xi-xj)*(yi-yj)>0)-(theta+1)/(theta+2)  )
          }
        }
      }
      u
    }

    if((U.func(lower)<0)&(U.func(upper)<0)){ theta=lower }else{
      theta=uniroot(U.func,lower=lower,upper=upper)$root
    }
    tau=theta/(theta+2)

    if(U.plot==TRUE){
      curve(U.func,lower,upper,xlab=expression(theta),
            ylab=expression(U[1](theta)))
      points(theta,U.func(theta),col="red",cex=1)
      abline(h=0,lty="dotted",col="blue")
    }

    return(c(theta=theta,tau=tau))
}

U1.Gumbel<-function(x.obs,y.obs,dx,dy,lower=0.01,upper=50,U.plot=TRUE){

  n=length(x.obs)
  x.ox=x.obs[order(x.obs)]
  y.oy=y.obs[order(y.obs)]
  d.ox=dx[order(x.obs)]
  d.oy=dy[order(y.obs)]
  Sx.vec=cumprod(1-d.ox/n:1)
  Sy.vec=cumprod(1-d.oy/n:1)
  Sx.vec=c(1,Sx.vec[-n])
  Sy.vec=c(1,Sy.vec[-n])
  x.ox=as.numeric(levels(factor(sort(x.obs))))
  nx=length(x.ox)
  y.oy=as.numeric(levels(factor(sort(y.obs))))
  ny=length(y.oy)
  Sx.vec=numeric(nx)
  Sy.vec=numeric(ny)
  Sx=Sy=1
  for(i in 1:nx){
    Dx=sum((x.obs==x.ox[i])&(dx==1))
    Rx=sum(x.obs>=x.ox[i])
    Sx=Sx*(1-Dx/Rx)
    Sx.vec[i]=Sx
  }
  for(i in 1:ny){
    Dy=sum((y.obs==y.oy[i])&(dy==1))
    Ry=sum(y.obs>=y.oy[i])
    Sy=Sy*(1-Dy/Ry)
    Sy.vec[i]=Sy
  }
  Sx.vec=pmax(Sx.vec,1/n);Sy.vec=pmax(Sy.vec,1/n)

  U.func=function(theta){
    u=0
    for(i in 1:(n-1)){
      xi=x.obs[i];yi=y.obs[i];dxi=dx[i];dyi=dy[i]
      for(j in (i+1):n){
        xj=x.obs[j];yj=y.obs[j];dxj=dx[j];dyj=dy[j]
        Ox=(dxi&dxj)|(dxi&(!dxj)&(xi<xj))|((dxj)&(!dxi)&(xj<xi))
        Oy=(dyi&dyj)|(dyi&(!dyj)&(yi<yj))|((dyj)&(!dyi)&(yj<yi))
        if(Ox&Oy){
          xij=min(xi,xj);yij=min(yi,yj)
          Rij=sum( (x.obs>=xij)&(y.obs>=yij) )
          Sx=Sx.vec[sum(x.ox<=xij)];Sy=Sy.vec[sum(y.oy<=yij)]
          Sij=exp(-( (-log(Sx))^(theta+1)+(-log(Sy))^(theta+1) )^(1/(theta+1)))
          Wij=(2*log(Sij)-theta)/(log(Sij)-theta)/(theta-Rij*log(Sij))
          u=u+Wij*(  ((xi-xj)*(yi-yj)>0)-1+1/(2-theta/log(Sij))  )
        }
      }
    }
    u
  }

  if((U.func(lower)<0)&(U.func(upper)<0)){ theta=lower }else{
    theta=uniroot(U.func,lower=lower,upper=upper)$root
  }
  tau=theta/(theta+1)

  if(U.plot==TRUE){
    curve(U.func,lower,upper,xlab=expression(theta),
          ylab=expression(U[1](theta)))
    points(theta,U.func(theta),col="red",cex=1)
    abline(h=0,lty="dotted",col="blue")
  }

  return(c(theta=theta,tau=tau))
}

simu.Gumbel=function(n,alpha,scale1=1,scale2=1,shape1=1,shape2=1,
                     Print=FALSE){

  U.vec=V.vec=X.vec=Y.vec=numeric(n)
  for (i in 1:n){
    U=runif(1, 0, 1)
    W=runif(1, 0, 1)
    Gumbul = function(v){
      A=(-log(U))^alpha/U*((-log(U))^(alpha+1)+(-log(v))^(alpha+1))^(-alpha/(alpha+1))
      A*exp(-((-log(U))^(alpha+1)+(-log(v))^(alpha+1))^(1/(alpha+1)))-W
    }
    V=uniroot(Gumbul,lower=0.00000000001,upper=0.9999999999)$root

    U.vec[i]=U
    V.vec[i]=V
    X.vec[i]=(-log(U)/scale1)^(1/shape1)
    Y.vec[i]=(-log(V)/scale2)^(1/shape2)
  }

  if(Print==TRUE){
    meanX=scale1^(-1/shape1)*gamma(1+1/shape1)
    meanY=scale2^(-1/shape2)*gamma(1+1/shape2)
    print(
      c(true_Kendall_tau=alpha/(alpha+1),meanX=meanX,meanY=meanY)
    )
  }

  cbind(U=U.vec,V=V.vec,X=X.vec,Y=Y.vec)
}

\name{Test.Gumbel}
\alias{Test.Gumbel}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{A goodness-of-fit test for the Gumbel copula}
\description{
Perform a goodness-of-fit test for the Gumbel copula based on Emura, Lin and Wang (2010).
}
\usage{
Test.Gumbel(x.obs,y.obs,dx,dy,lower=0.01,upper=50,U.plot=TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x.obs}{censored times for X}
  \item{y.obs}{censored times for Y}
  \item{dx}{censoring indicators for X}
  \item{dy}{censoring indicators for Y}
  \item{lower}{lower bound for the association parameter}
  \item{upper}{upper bound for the association parameter}
  \item{U.plot}{if TRUE, draw the plot of U_1(theta) and U_2(theta)}
}

\details{
See the references.
}

\value{
  \item{theta1}{association parameter by the pseudo-likelihood estimator}
  \item{theta2}{association parameter by the unweighted estimator}
  \item{Stat}{log(theta1)-log(theta2)}
  \item{Z}{Z-value of the goodness-of-fit for the Clayton copula}
  \item{P}{P-value of the goodness-of-fit for the Clayton copula}
}
\references{
Emura T, Lin CW, Wang W (2010) A goodness-of-fit test for Archimedean copula models
 in the presence of right censoring, Compt Stat Data Anal 54: 3033-43
}
\author{Takeshi Emura}

\examples{
x.obs=c(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15)
y.obs=c(2,1,4,5,6,8,3,7,10,9,11,12,13,14,15)
dx=c(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1)
dy=c(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1)
Test.Gumbel(x.obs,y.obs,dx,dy)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ Gumbel copula }% use one of  RShowDoc("KEYWORDS")
\keyword{ Goodness-of-fit test }% __ONLY ONE__ keyword per line

\name{simu.Clayton}
\alias{simu.Clayton}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Simulating data from the Clayton copula}
\description{
n pairs of (U,V) are generated from the Clayton copula.
n paris of (X,Y) are generated from the corresponding bivariate survival model with the Weibull marginal distributions. The default parameters (scale1=scale2=shape1=shape2=1) give the unit exponential distributions.
}
\usage{
simu.Clayton(n,alpha,scale1=1,scale2=1,shape1=1,shape2=1,Print=FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{n}{sample size}
  \item{alpha}{association (copula) parameter}
  \item{scale1}{scale parameter for X}
  \item{scale2}{scale parameter for Y}
  \item{shape1}{shape parameter for X}
  \item{shape2}{shape parameter for Y}
  \item{Print}{print Kendall's tau and means of X and Y if "TRUE"}
}

\details{
See Section 2.6 of Emura et al.(2019) for copulas and bivariate survival times.
}

\value{
  \item{U}{uniformly distributed on (0,1)}
  \item{V}{uniformly distributed on (0,1)}
  \item{X}{Weibull distributed (scale1, shape1)}
  \item{Y}{Weibull distributed (scale2, shape2)}
}
\references{
Emura T, Lin CW, Wang W (2010) A goodness-of-fit test for Archimedean copula models in the presence of right censoring, Compt Stat Data Anal 54: 3033-43

Emura T, Matsui S, Rondeau V (2019), Survival Analysis with Correlated Endpoints, Joint Frailty-Copula Models, JSS Research Series in Statistics, Springer
}
\author{Takeshi Emura}

\examples{
n=100
Dat=simu.Clayton(n=n,alpha=1,scale1=1,scale2=2,shape1=0.5,shape2=2)
plot(Dat[,"U"],Dat[,"V"])
cor(Dat[,"U"],Dat[,"V"],method="kendall")
plot(Dat[,"X"],Dat[,"Y"])
cor(Dat[,"X"],Dat[,"Y"],method="kendall")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ Clayton copula }% use one of  RShowDoc("KEYWORDS")
\keyword{ Simulation }% __ONLY ONE__ keyword per line
\keyword{ Weibull distribution }% __ONLY ONE__ keyword per line

\name{Weib.reg.cBB1.0}
\alias{Weib.reg.cBB1.0}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Weibull regression under the conditional BB1 copula with known "delta"}
\description{
See Section 2.6.3 of Emura et al. (2019).
}
\usage{
Weib.reg.cBB1.0(x.obs,y.obs,dx,dy,zx,zy,zxy,delta=0,convergence.par=FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x.obs}{censored times for X}
  \item{y.obs}{censored times for Y}
  \item{dx}{censoring indicators for X}
  \item{dy}{censoring indicators for Y}
  \item{zx}{matrix of covariates for X}
  \item{zy}{matrix of covariates for Y}
  \item{zxy}{matrix of covariates for copula}
  \item{delta}{known copula parameter (d>=0)}
  \item{convergence.par}{if TRUE, show the details}
}

\details{
Details are seen from the references.
}

\value{
  \item{beta_x}{regression coefficients for X}
  \item{beta_y}{regression coefficients for Y}
  \item{beta_xy}{regression coefficients for copula}
  \item{alpha}{copula parameter}
  \item{tau}{Kendall's tau given beta_xy=0}

}
\references{
Emura T, Matsui S, Rondeau V (2019), Survival Analysis with Correlated Endpoints, Joint Frailty-Copula Models, JSS Research Series in Statistics, Springer
}
\author{Takeshi Emura}

\examples{#TBA}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ BB1 copula }% use one of  RShowDoc("KEYWORDS")
\keyword{ Regression }% __ONLY ONE__ keyword per line

\name{Copula.surv-package}
\alias{Copula.surv-package}
\alias{Copula.surv}
\docType{package}
\title{
Analysis of Bivariate Survival Data
}
\description{
 Simulating bivariate survival data from copula models (Emura et al. 2019).
 Estimation of the association parameter in copula models.
 Two different ways to estimate the association parameter in copula models are implemented.
 A goodness-of-fit test for a given copula model is implemented.
 See Emura, Lin and Wang (2010) <doi:10.1016/j.csda.2010.03.013> for details.
 Also, Weibull regression is implemented (Section 2.6.3 of Emura et al. (2019)).
}
\details{
Details are seen from the references.
}
\author{
Takeshi Emura
Maintainer: Takeshi Emura <takeshiemura@gmail.com>
}
\references{
Emura T, Lin CW, Wang W (2010) A goodness-of-fit test for Archimedean copula models
 in the presence of right censoring, Compt Stat Data Anal 54: 3033-43

Emura T, Matsui S, Rondeau V (2019), Survival Analysis with Correlated Endpoints, Joint Frailty-Copula Models, JSS Research Series in Statistics, Springer
}
\keyword{ package }

\name{U2.Clayton}
\alias{U2.Clayton}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Estimation of an association parameter via the unweighted estimator}
\description{
Estimate the association parameter of the Clayton copula using bivariate survival data.
 The estimator was defined as the unweighted estimator in Emura, Lin and Wang (2010).
}
\usage{
U2.Clayton(x.obs,y.obs,dx,dy,lower=0.001,upper=50,U.plot=TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x.obs}{censored times for X}
  \item{y.obs}{censored times for Y}
  \item{dx}{censoring indicators for X}
  \item{dy}{censoring indicators for Y}
  \item{lower}{lower bound for the association parameter}
  \item{upper}{upper bound for the association parameter}
  \item{U.plot}{if TRUE, draw the plot of U_2(theta)}
}

\details{
Details are seen from the references.
}

\value{
  \item{theta}{association parameter}
  \item{tau}{Kendall's tau (=theta/(theta+2))}
}
\references{
Emura T, Lin CW, Wang W (2010) A goodness-of-fit test for Archimedean copula models
 in the presence of right censoring, Compt Stat Data Anal 54: 3033-43
}
\author{Takeshi Emura}

\examples{
n=200
theta_true=2 ## association parameter ##
r1_true=1 ## hazard for X
r2_true=1 ## hazard for Y

set.seed(1)
V1=runif(n)
V2=runif(n)
X=-1/r1_true*log(1-V1)
W=(1-V1)^(-theta_true)
Y=1/theta_true/r2_true*log(  1-W+W*(1-V2)^(-theta_true/(theta_true+1))  )
C=runif(n,min=0,max=5)

x.obs=pmin(X,C)
y.obs=pmin(Y,C)
dx=X<=C
dy=Y<=C

U2.Clayton(x.obs,y.obs,dx,dy)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ Clayton copula }% use one of  RShowDoc("KEYWORDS")
\keyword{ Goodness-of-fit test }% __ONLY ONE__ keyword per line
